/* kerhomain.cpp */
/*
** Kerho-ohjelman pohjelma
**
** Tekijt:          Vesa Lappalainen
**                   Ohjelmointikurssit 1991-1997
** Tehty:            20.12.1991
** Muutettu          19.12.1993/vl
**                   06.12.1995/vl  - C++ versio
** Mit muutettu:    avustus
** Muutettu          06.12.1995/vl
** Mit muutettu:    tehty C++ versio
** Muutettu          07.12.1995/vl
** Mit muutettu:    tehty document/view C++ versio
** Muutettu          09.12.1995/vl
** Mit muutettu:    jaettu osiin
** Muutettu          11.01.1996/vl
** Mit muutettu:    + argv-ksittely jotta voidaan kynnist:
**                      kerho kelmit
**                     onnistuu lue_tiedosto(argv[1]), koska standardi
**                     takaa ett argv[1] == NULL tai osoitin merkkijonoon
** Muutettu          20.01.1997/vl
** Mit muutettu:    kerho ja jsenist eri luokiksi
** Muutettu          03.04.2000/vl
** Mit muutettu:    const char *:i poistettu
**                   poistettu ystvyyksi
**                   kerholle lis tit
** Muutettu          20.01.2001/vl
**                   korjattu bugi argumenttien kSsittelyssS
** Muutettu:         28.12.2001/vl
** Mita muutettu:    Jsenten etsiminen ja korjailu
**                   Lisatty vakion DOSOUT tutkiminen.  Jos vakio maritelty
**                   muutetaan ANSI-merkit OEM-merkeiksi tulostuksessa.
**                   Talloin projektiin pitaa lisata myos dout.cpp
**
**
** Projektiin mukaan:
**
**  kerhomain.cpp      - tm tiedosto
**  jasen.cpp          - yksittisen jsenen ksittely
**  jasenet.cpp        - jsenistn ksittely
**  kerho.cpp          - kerhon ksittely kokonaisuudessaan
**  naytto.cpp         - nyttn liittyv kerhon ksittely
**  muunnos.c          - jasenen vaatimat muunnokset merkkijonoksi ja takaisin
**  kentta.cpp         - tietueen kentt-luokka
**  CPP\ALI\help.c     - avustusten ksittely
**  CPP\ALI\ioali.c    - yleiskyttiset kyttjrjestelm-riippuvat io-rut.
**  CPP\ALI\mjonot.c   - yleikyttisi aliohjelmia merkkijonojen
**                       ksittelyyn
**  CPP\ALI\pvm.c      - pivmrn ksittely
**  CPP\ALI\vstring.cpp- c++ -merkkijonoluokka (korvike std-versiolle)
**                       (HUOM!  Vain jollei string ole jo mukana systeemiss)
**  CPP\ALI\mjonotpp.cpp - mjonot++ string-luokan ksittelyyn
**  CPP\ALI\lyhenne.c    - hoitaa lyhenteiden ksittelyn
**
** Lisksi tarvitaan tietysti otsikkotiedostot:
**
**  help.h
**  kentta.h
**  jasen.h
**  jasenet.h
**  kerho.h
**  naytto.h
**  muunnos.h
**  CPP\ALI\help.h
**  CPP\ALI\pvm.h
**  CPP\ALI\ioali.h
**  CPP\ALI\mjonot.h
**  CPP\ALI\mjonotpp.h
**  CPP\ALI\lyhenne.h
**  CPP\ALI\wout.h       - konsolille tulosta tietovirta
**
** Jos halutaan kytt rivieditointia, pit projektiin laittaa
** lisksi
**  CPP\ALI\console.c    - konsolia ksttelevt funktiot
**  CPP\ALI\wout.cpp     - konsolille tulostava tietovirta
**  CPP\ALI\editlue.c    - korvaa lue_jono_oletuksen lukemisen
**
** Samalla pit mrietll kntmiseen vakio USE_CONSOLE
** Tarvitaan tietysti viel h-tiedosto
**  CPP\ALI\console.h
**
**
** Luokkahierarkia:
**
**  string   - yleinen merkkijonoluokka
**  cKentta  - yleinen kentttyyppi + sen perilliset
**  cJasen   - jsenen ominaisuudet (ks. jasen.cpp ja jasen.h)
**  cJasenet - jsenet kokoava tietorakenne (ks. jasenet.cpp ja jasent.h)
**  cKerho   - kerhon ksittely kokonaisuudessaan
**  cNaytto  - kyttliittym yllpitv luokka (sislt osoittimen
**             kerhoon, ks. naytto.cpp ja naytto.h)
**
** Jos tm ohjelma halutaan kirjoittaa muulle kuin standardiptteelle,
** esim. johonkin graafiseen kyttjrjestelmn, pit kirjoittaa uusiksi
**
**  naytto-luokka    - joutuu tydelliseen remonttiin, voi jopa
**                     tulla lis toimintoja, kuten "Avaa uusi nkym"
**  kerhomai.cpp     - tm pohjelma
**  ioali.?          - korvautuu todennkisesti kyttliittymn vast.
**                     rutiineilla
*/

#include "kerho.h"
#include "naytto.h"


int main(int argc, char *argv[])
{
  cKerho kerho;
  cNaytto naytto(&kerho,argv[0]);
  naytto.ohjeet();

  string tiedosto;
  if ( argc > 1) tiedosto = argv[1];

  if ( naytto.lue_tiedosto(tiedosto) != 0 ) return 1;

  naytto.paavalinta();

  if ( naytto.talleta() != 0 ) return 2;
                           
  naytto.kiitokset();

  return 0;
}
