/* muunnos.h */
/****************************************************************************/
/*
**       M U U N N O S . H
**
** Kerho-ohjelman yleisi merkkijonofunktioita.
**
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991
**  Tehty:            20.12.1991
**  Muutettu:         6.12.1993/vl
**  Mit muutettu:    enemmn erikoisarvoja
**  Muutettu:         10.12.1995/vl
**  Mit muutettu:    irroitettu pelkt muunnokset omaksi tiedostokseen
**  Muutettu:         07.01.1996/vl
**  Mit muutettu:    muunosfunktioita kentt-tyyppi varten
**  Muutettu:         05.04.2000/vl
**  Mit muutettu:    hetun vlimerkiksi mys A
**
**  Kommentit ks. muunnos.c
**
*****************************************************************************/

#ifndef __MUUNNOS_H
#define __MUUNNOS_H

#ifdef __cplusplus
extern "C" {
#include <limits.h>
#else
#include <limits.h>
#endif

#define TYHJA_ARVO    (INT_MIN+1) /* Arvo joka kuvastaa tyhj num. kentt */
#define TYHJENNA_ARVO (TYHJA_ARVO+1)/* Arvo joka kuvastaa kentn tyhjennyst  */
#define TYHJENNA_JONO "=="        /* Jono, joka pakottaa kentn tyhjksi    */

/****************************************************************************/
int                       /* 0 = ei                                         */
onko_tyhjenna_jono(       /* 1 = p:ss oleva jono kskee tyhjentmn kentn*/
  const char *p           /*                                                */
);
char                      /*                                                */
*int_jonoksi(             /* Jonon osoite                                   */
  char *jono             ,/* t   Jono, jonne tulos tulee                    */
  int max_pit            ,/* s   Jonon maksimipituus                        */
  int arvo               ,/* s   Arvo joka muutetaan jonoksi.               */
  const char *formaatti   /* s   Formaatti, jota muutoksessa kytetn      */
);
char                      /*                                                */
*double_jonoksi(          /* Jonon osoite                                   */
  char *jono             ,/* t   Jono, jonne tulos tulee                    */
  int max_pit            ,/* s   Jonon maksimipituus                        */
  double arvo            ,/* s   Arvo joka muutetaan jonoksi.               */
  const char *formaatti   /* s   Formaatti, jota muutoksessa kytetn      */
);
int                       /*                                                */
jono_intiksi(             /*                                                */
  const char *jono       ,/* s   Kokonaisluvuksi muutettava merkkijono      */
  const char *formaatti   /* s   Formaatti jota muunnoksessa kytetn.     */
);
double                    /*                                                */
jono_doubleksi(           /*                                                */
  const char *jono       ,/* s   Reaaliluvuksi muutettava merkkijono        */
  const char *formaatti   /* s   Formaatti jota muunnoksessa kytetn.     */
);


                       /* 0         1         2         3 */
                       /* 0123456789012345678901234567890 */
#define     HETUTARK     "0123456789ABCDEFHJKLMNPRSTUVWXY"
#define     HETUVALI     "A+-"
#define     PUH_MERKIT   "0123456789- "


char *int_muunnos(char *s);
char *double_muunnos(char *s);
char *hetu_muunnos(char *s);
char *puh_muunnos(char *s);
char *arvosana_muunnos(char *s);
char *numerot_muunnos(char *s);


#ifdef __cplusplus
}
#endif


#endif

