/* naytto.cpp */
/****************************************************************************/
/*
**        N A Y T T O . C P P
**
** Nytt-luokan toteutus
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991
**  Tehty:            20.12.1991
**  Muutettu:         10.12.1995
**  Mit muutettu:    Muutettu C++ luokaksi
**  Muutettu:         28.12.1995/vl
**  Mit muutettu:    Laitettu uuden jsenen lukeminen toimivaksi
**  Muutettu:         02.01.1996/vl
**  Mit muutettu:    Listty oikeellisuustarkistus ja valmius
**                    lista-tyyppisiin kenttiin
**                    ks. kysy_tavallinen_kentta ja kysy_listakentta
**                    Listty helpin kytt
**  Muutettu:         07.01.1996/vl
**  Mit muutettu:    Listty mahdollisuus knt mrittelemll
**                    vakio USE_CONSOLE ja lismll tllin editlue.c:n
**                    vaatimat muut tiedosto projektiin.  Nin voidaan
**                    saada nytteditointi mukaan silloin kuin
**                    console.c on kohdelaitteistolle sovitettu
**                    (7.1.1996: BorlandC, HP-UX, Linux, AIX, ks. console.c)
**  Muutettu:         20.01.1997/vl
**  Mit muutettu:    Jsenet erilleen kerhosta
**                    lue_tiedosto ja cNaytto(...) parametrilistaa muutettu
**                    jotta voidaan lukea esim. komento rivill annettu tied.
**  Muutettu:         28.12.2001/vl
**  Mit muutettu:    Jsenten etsint ja korjailu
**
**
** Tietorakenne on seuraava:
**
**
**   cNaytto    cKerho
**   ------
**   | o-----> |---|
**   |    |    |   |
**   |    |    |   |
**   |    |    |   |
**   |    |    |---|
**   ------
**
**  Kytss voi olla monta nytt, joista jokainen voi osoittaa samaan
**  tai eri kerhoon.  Nytt huolehtii kaikesta kyttliittymn
**  liittyvst.  Nytt ei tied kerhon rakenteesta muuta kuin, ett
**  kerhon voi lukea levylt ja kirjoittaa levylle sek siihen voi
**  list ja etsi jseni.  Nytt tiet ett on olemassa jsen,
**  muttei se tied jsenen yksityiskohtia.
**
**  Nyttluokka voidaan kirjoittaa uusiksi esimerkiksi Windows-
**  toteuteusta varten.  Tm nyttluokka on ANSI C++:n mukainen,
**  standardi-ptett kyttv versio.
**
** Public-metodeja:
** ================
**  cNaytto(cKerho *p)
**   - alustetaan naytto kayttaen naytossa kerhoa johon p osoittaa
**
**  ~cNaytto()
**   - hvitetn nytt.  Talletetaan jollei ole viel tehty
**
**  void ohjeet(void);
**   - lyhyt tiedotus ohjelmasta
**
**  void kiitokset(void);
**   - poistumiskiitokset
**
**  int  lue_tiedostosta();
**   - luetaan kerhon nimi ja sitten luetaan kerho tiedostosta
**     Luodaan uusi, jollei kerhoa lydy levylt.
**
**  int  talleta();
**   - talletaan kerho levylle (jos siin on muutoksia).
**     vanha kerho j .bak -nimelle
**
**  int  paavalinta();
**   - tulostetaan pmenu ja odotetaan valintaa sek suoritetaan
**     valittu toimenpide.  Toistetaan silmukassa kunnes valitaan
**     poistuminen.
**     Toistaiseksi vasta lisminen toimii Aku Ankalla ja
**     tulostus alkeellisesti nyttn
**
**
*/

#include <iostream.h>
#include <string.h>
#include <string>
using namespace std;
#include "naytto.h"
#include "ioali.h"
#include "mjonotpp.h"
#include "editlue.h" // Tm vaikuttaa vain jos on vakio USE_CONSOLE
#include "help.h"
#include "kentta.h"
#include "wout.h"

//============================================================================
// Vakiota
//============================================================================
#define VERSIO "2001.12.28"

static const int   OLET_ALKU = 19;
static const int   VAKANEN   = 33;

static const char *TARKENNIN = ".dat";
static const char *VANHATARK = ".bak";

//============================================================================
// Merkkijonot, jotka tarkoittavat jotakin toimintoa ja niiden ksittely
//============================================================================
typedef struct {
  eToiminto komento;
  const char *jono;
} tKomento;

static tKomento komennot[] = {
  { TOIM_LOPETA      , "q"   },
  { TOIM_EDELLINEN   , "^"   },
  { TOIM_LOPUT_OLETUS, ",|." },
  { TOIM_JATKA       , NULL  }
};

static eToiminto mika_komento(const string &s)
{
  for (int i=0; komennot[i].jono; i++)
    if ( joku_jono(s,komennot[i].jono,"|") == 0 ) return komennot[i].komento;
  return TOIM_JATKA;
}

//============================================================================
// Nytn yleinen ksittely:
//============================================================================


void cNaytto::logo(void)
{
  cout << endl;
  cout << "      ###################################" << endl;
  cout << "      #   J  S E N R E K I S T E R I   #" << endl;
  cout << "      #     versio 9.95                 #" << endl;
  cout << "      #     Hannu Hanhi                 #" << endl;
  cout << "      ###################################" << endl;
}


void cNaytto::ohjeet(void)
{
  logo();
  cout << endl;
  cout << "Tll ohjelmalla yllpidetn kerhon jsenrekisteri." << endl;
}


void cNaytto::kiitokset(void)
{
  cout << endl;
  cout << "KIITOS KYTST JA TERVETULOA UUDELLEEN" << endl;
  cout << endl << endl << endl;
}


//============================================================================
// Nytn kerhon tunteva osuus:
//============================================================================

//----------------------------------------------------------------------------
int cNaytto::lue_tiedosto(const string &tied_nimi)
/*
** Luetaan kerho levylt.
** Ensin kysytn kerhon nimi.  Jos kerhoa ei ole, utellaan
** listietoja ja luodaan se.
----------------------------------------------------------------------------*/
{
  string tied,nimi; int maksimi;

  if ( tied_nimi != "" ) { tied = tied_nimi; goto jatka; }
  if ( kerho->Tiedoston_nimi() != "" ) {
    tied = kerho->Tiedoston_nimi(); goto jatka;
  }  // Poista goto??

  do { // Kyselln kunnes tiedosto aukeaa tai luodaan uusi
    cout << endl;
    cout << "Anna kerhon nimi>";  lue_rivi(cin,tied);
    if ( tied == "" ) return ilmoitus("Tiedoston nime ei annettu");

jatka:
    laita_tarkennin(tied,TARKENNIN);
    if ( onko_tiedostoa(tied) ) return ilmoitus(kerho->lue_tiedostosta(tied));

    cout << "Tiedostoa " << tied << " ei ole!" << endl;
  } while ( kylla_kysymys("Luodaanko uusi tiedosto?") == 0 );

  cout << endl;
  cout << "Anna kerhon koko nimi    >";  lue_rivi(cin,nimi);
  cout << "Anna kerhon maksimi koko >";  lue_rivi(cin,maksimi);

  return ilmoitus(kerho->luo(tied,nimi,maksimi));

}


//----------------------------------------------------------------------------
int cNaytto::talleta()
/*
** Jos kerhossa muutoksia, niin
** Nimetn vanha tiedosto .bak -nimelle ja talletetaan
** nykyinen tiedosto vanhan tilalle.
----------------------------------------------------------------------------*/
{
  logo();
  if ( !kerho->Muutettu() ) return 0;
  int vanhat_pilalla = kerho->TeeBak(VANHATARK);

  if ( ilmoitus(kerho->talleta()) ) return 1;

  cout << endl;
  cout << "Tiedot talletettu tiedostoon "
       << kerho->Tiedoston_nimi() << endl;
  if ( !vanhat_pilalla )
    cout << "Vanhat tiedot tiedostossa    "
         << kerho->Bak_nimi() << endl;

  return 0;
}


//----------------------------------------------------------------------------
int cNaytto::kysy_talleta()
{
  if ( !kerho->Muutettu() ) return 0;
  if ( kylla_kysymys("Talletetaanko tiedot") ) return talleta();
  return 0;
}


//----------------------------------------------------------------------------
void cNaytto::tulosta(std::ostream &os,const cJasen &jasen)
{
  jasen.tulosta(os);
}

/****************************************************************************/
static eToiminto          /*                                                */
kysy_kentta(              /*                                                */
  const string &viesti   ,/* s   Viesti joka tulee nytlle                 */
  string &jono            /* t   Jono johon kentn vastaus luetaan.         */
)
/*
** Funktiolla luetaan vastaus kenttn.
**
** Globaalit: POIS (jono, jolla sytt katkaistaan)
** Sytt:    ptteelt
** Tulostus:  nyttn
** Kutsuu:    lue_jono_oletus
----------------------------------------------------------------------------*/
{
  string apu(jono); int paluu;
  eToiminto toim;

  paluu = lue_jono_oletus(viesti,OLET_ALKU,VAKANEN,apu);

  if ( paluu < OLETUS ) return TOIM_LOPETA;
  if ( ( toim  = mika_komento(apu) ) != TOIM_JATKA ) return toim;

  poista_tyhjat(apu);
  jono = apu;

  return TOIM_JATKA;
}

//----------------------------------------------------------------------------
eToiminto cNaytto::kysy_tavallinen_kentta(cJasen &jasen, int k)
/*
** Kysytn tavallisen kentn tiedot.  Palautetaan tieto miten pit
** jatkaa:
**  TOIM_LOPETA          - ei kysell en, eik jsenen tietoja saa kytt
**  TOIM_SEURAAVA        - voi kysy seuraav kentn tiedot
**  TOIM_EDELLINEN       - tytyy kysy edellisen kentn tiedot
**  TOIM_KYSY_UUDELLEEN  - tiedot tytyy kysy uudelleen
**
** 1. kysymyksest psee pois pelkll RETURNin painamisella.
** Jos yritetn list sellaisia kentti,, joista tytyy olla
** yksiksitteinen arvo, joko varoitetaan tai kieltydytn lismisest.
** Kentn sijoittaminen osaa ilmoittaa tmn.
**
** Toteuteuksessa on viel se vika, ett jos palataan edelliseen jo
** kerran varmistettuun kenttn, niin taas kentst poistuttaessa
** varmistus kysytn uudelleen.  Vika saataisiin pois mrittelemll
** taulukko, johon merkitn mitk kentt on jo hyvksytty.  Hyvksynt
** pit tietysti aina poistaa jos kentn sislt muuttuu!
----------------------------------------------------------------------------*/
{
  int lkm,kuka;
  cKenttavirhe virhe;
  eToiminto toiminto;
  string edell; // Apumuuttuja johon jemmataan kentn vanha arvo
  string jono;

  edell = jono = jasen.kentta_jonoksi(k);

  edit_vaihda_muunnos(jasen.kentta_muunnos(k));  // Jos nytteditointi

  toiminto = kysy_kentta(jasen.kysymys(k),jono);
  if (  toiminto != TOIM_JATKA ) return toiminto;

  if ( k == jasen.eka_kysymys() && jono == "" )
    return TOIM_LOPETA; // 1. kys. pois pelk. ret

  if ( jono == HELP_JONO ) {
    help.aihe(jasen.help_aihe(k));
    return TOIM_KYSY_UUDELLEEN;
  }

  virhe = jasen.sijoita(k,jono);

  switch ( virhe.Taso() ) {
    case KENTTA_OK:
      return TOIM_SEURAAVA;

    case KENTTA_VAROITUS:
      cout << virhe.Virhe() << endl;
      return TOIM_SEURAAVA;

    case KENTTA_UUDELLEEN:
    case KENTTA_MUUTETTU_KYSY:
      cout << virhe.Virhe() << endl;
      return TOIM_KYSY_UUDELLEEN;

    case KENTTA_OK_ONKO_AINOA:
      lkm = kerho->laske_montako_muuta(jasen,k,kuka);
      if ( lkm == 0 ) return TOIM_SEURAAVA;
      kerho->anna_jasen(kuka).tulosta(cout);
      cout << "On jo ennestn!" << endl;
      jasen.sijoita(k,edell);
      return TOIM_KYSY_UUDELLEEN;

    case KENTTA_OK_VAROITA_MUUT:
      lkm = kerho->laske_montako_muuta(jasen,k,kuka);
      if ( lkm == 0 ) return TOIM_SEURAAVA;
      kerho->anna_jasen(kuka).tulosta(cout);
      if ( kylla_kysymys("On jo, listnk silti uusi!") )
        return TOIM_SEURAAVA;
      jasen.sijoita(k,edell);
      return TOIM_KYSY_UUDELLEEN;

    default: ;
  } // virhe.Taso()
  return TOIM_SEURAAVA;
}


//----------------------------------------------------------------------------
int cNaytto::kysy_tiedot(cJasen &jasen)
{
  cJasen apujasen(jasen);
  int k,eka=apujasen.eka_kysymys(),kenttia = apujasen.kenttia();
  eToiminto toiminto;

  k = eka;

  do {
    if ( k < eka ) k = eka;

    switch ( apujasen.kentan_tyyppi(k) ) {
      case KENTTA_NORMAALI:
        toiminto = kysy_tavallinen_kentta(apujasen,k);
        break;
      case KENTTA_LISTA:
        toiminto = kysy_listakentta(apujasen,k);
        break;
      default: return 1;
    }

    switch ( toiminto ) {
      case TOIM_SEURAAVA:       k++;         break;
      case TOIM_EDELLINEN:      k--;         break;
      case TOIM_KYSY_UUDELLEEN:              break;
      case TOIM_LOPUT_OLETUS:   k = kenttia; break;
      case TOIM_LOPETA:                      return 1;
      default: ;
    }

  } while ( k < kenttia );

  jasen = apujasen;
  return 0;
}


//----------------------------------------------------------------------------
eToiminto cNaytto::kysy_listakentta(cJasen &, int )
/*
** Kysytn listatyyppisen kentn tiedot.
** Ei toteutettu!
----------------------------------------------------------------------------*/
{
  return TOIM_SEURAAVA;
}


//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
void cNaytto::lisaa_uusi_jasen(char valinta)
/*
** Kyselln uusien jsenien tietoja ja listn jsenet.
----------------------------------------------------------------------------*/
{
  cJasen jasen(kerho->anna_jasen(nykyjasen));  // Kerho hoitaa jos -1

  otsikko(valinta,"Uuden jsenen lisys");

  while ( 1 ) {
    jasen.tyhjenna_omat();
    jasen.rekisteroi();
    cout << endl;
    cout << "Jseni on nyt " << kerho->Jasenia() << "." << endl;
    cout << "Anna uusi nimi muodossa sukunimi etunimi" << endl;

    do {
      if ( kysy_tiedot(jasen) != 0 ) return;

      cout << "Listnk" << endl;
      jasen.tulosta(cout);
    } while ( kylla_kysymys("") == 0 );

    if ( ilmoitus(kerho->lisaa(jasen)) ) return;
    nykyjasen = kerho->Jasenia()-1;
  }
}

void cNaytto::korjaile_jasenta(int ind)
{
  cout << "\n\n";
  cJasen apujasen(kerho->anna_jasen(ind));
  if ( kysy_tiedot(apujasen) ) return;
  kerho->korvaa(ind,apujasen);
}

bool cNaytto::poista(int ind)
{
  cout << "\n\n";
  if ( !kylla_kysymys("Poistetaanko jsen") ) return false;
  kerho->poista_ind(ind);
  return true;
}

//----------------------------------------------------------------------------
// Aliohjelmia etsimisen avuksi:
//----------------------------------------------------------------------------

static void tutki_ja_tulosta_muut(const cPermutaatio &loytyneet,bool korjaile,
                           unsigned int kohdalla,string &muut)
{
  string erotin = "\n";
  muut = "";
  if ( korjaile ) {
    muut += "PK";
    cout << erotin + "P = poisto, K = korjailu"; erotin = ", ";
  }

  int ero = loytyneet.size()-1 - kohdalla;
  if ( ero > 0 ) {
    muut += '+';
    cout << erotin + "+ = seuraava (" << ero << ")"; erotin = ", ";
  }

  ero = kohdalla;
  if ( ero > 0 ) {
    muut += '-';
    cout << erotin + "- = edellinen (" << ero << ")"; erotin = ", ";
  }
}

static string merkit="0123456789ABCDEFGHIJKLMNOPQRS";
const char ESC = char(27);

void tayta_sallitut(string &sallitut)
{
  cJasen apujasen;
  sallitut = "";
  for (int i=apujasen.eka_kysymys();i<apujasen.kenttia(); i++) {
    char merkki = merkit[i];
    sallitut += merkki;
  }
  sallitut += string("?")+ESC;
}

bool tutki_muut(char nappula,const cPermutaatio &loytyneet,unsigned &kohdalla)
{
  if ( nappula == '?' ) {
    cJasen apujasen;
    cout << "\n\n";
    for (int j=apujasen.eka_kysymys();j<apujasen.kenttia(); j++) {
      char merkki = merkit[j];
      cout <<  merkki << " = " << apujasen.kysymys(j) << "\n";
    }
    return true;
  }

  if ( nappula == '+' ) {
    if ( kohdalla < loytyneet.size()-1 ) kohdalla++;
    return true;
  }

  if ( nappula == '-' ) {
    if ( kohdalla > 0 ) kohdalla--;
    return true;
  }
  return false;
}


void cNaytto::selaa_ja_korjaa(bool korjaile)
{
  if ( kerho->Jasenia() == 0 ) { cout << "Ei jseni\n"; odota_jotakin(); return; }

  cPermutaatio loytyneet; unsigned int kohdalla = 0;
  cJasen apujasen; string muut,sallitut,jono;  unsigned int k;

  if ( nykyjasen < 0 ) nykyjasen = 0;
  loytyneet.push_back(nykyjasen);  // Tulostetaan aina yksi
  tayta_sallitut(sallitut);

  cout << "Nykyinen henkil:\n";

  while ( 1 ) {
    if ( loytyneet.size() > 0 ) {
      if ( kohdalla >= loytyneet.size() ) kohdalla = loytyneet.size()-1; 
      nykyjasen = loytyneet[kohdalla];
      const cJasen &jasen = kerho->anna_jasen(nykyjasen);
      cout << "\n"; tulosta(cout,jasen);
    } else  {
      cout << "\nHakuhedolla ei lytynyt yhtn jsent!\n";
    }

    cout << "\n";
    cout << "Valitse kentt jonka mukaan etsitn (?=kenttlista uudel.) ";
    tutki_ja_tulosta_muut(loytyneet,korjaile,kohdalla,muut);
    cout << ":";

    char nappula = odota_nappain(sallitut+muut,ESC,MERKKI_ISOKSI);
    if ( nappula == ESC ) return;

    if ( tutki_muut(nappula,loytyneet,kohdalla) ) continue;
    if ( nappula == 'K' ) { korjaile_jasenta(nykyjasen); continue; }
    if ( nappula == 'P' ) {
      if ( poista(nykyjasen) ) loytyneet.erase(loytyneet.begin()+kohdalla);
      continue;
    }

    k = merkit.find(nappula);

    cout << "\n";
    if ( kysy_kentta(apujasen.kysymys(k),jono) != TOIM_JATKA ) return;
    if ( jono == "" ) return;

    loytyneet.clear();
    kerho->etsi(loytyneet,k,jono);
    kohdalla = 0;
  }
}


void cNaytto::etsi_jasenen_tiedot(char valinta)
{
  otsikko(valinta,"Etsi jsenen tiedot");
  selaa_ja_korjaa(false);
}



//----------------------------------------------------------------------------
void cNaytto::tulosteet(char valinta)
/*
** Tulostetaan kaikki jsenet nytlle.
----------------------------------------------------------------------------*/
{
  otsikko(valinta,"Tulosteet");
  cout << "Toimii toistaiseksi vain nytlle" << endl;
  viivarivi(78,'-');

  for (int i=0; i<kerho->Jasenia(); i++) {
    const cJasen &jasen = kerho->anna_jasen(i);
    tulosta(cout,jasen);
    cout << endl;
  }

  viivarivi(78,'-');
  odota_jotakin();
}


//----------------------------------------------------------------------------
void cNaytto::tietojen_korjailu(char valinta)
{
  otsikko(valinta,"Tietojen korjailu");
  selaa_ja_korjaa(true);
}


//----------------------------------------------------------------------------
void cNaytto::paivita_jasenmaksuja(char valinta)
{
  otsikko(valinta,"Pivit jsenmaksuja");
  ei_toimi();
}


//----------------------------------------------------------------------------
void cNaytto::avustus(char valinta)
{
  otsikko(valinta,"Avustus");
  help.hakemisto();
}


//----------------------------------------------------------------------------
void cNaytto::paamenu()
{
  cout << endl << endl << endl << endl << endl << endl;
  cout << "Jsenrekisteri"                            << endl;
  cout << "=============="                            << endl;
  cout << ""                                          << endl;
  cout << "Kerhossa " << kerho->Kerhon_nimi() << " on " <<
          kerho->Jasenia() << " jsent."             << endl;
  cout << ""                                          << endl;
  cout << "Valitse:"                                  << endl;
  cout << "   ?  = avustus"                           << endl;
  cout << "   0  = lopetus"                           << endl;
  cout << "   1  = lis uusi jsen"                  << endl;
  cout << "   2  = etsi jsenen tiedot"               << endl;
  cout << "   3  = tulosteet"                         << endl;
  cout << "   4  = tietojen korjailu"                 << endl;
  cout << "   5  = pivit jsenmaksuja"              << endl;
  cout << "   :";
}


//----------------------------------------------------------------------------
int cNaytto::paavalinta()
{
  char nappain;

  while (1) {

    paamenu();

    nappain = odota_nappain("?012345",EI_OLETUSTA,MERKKI_ISOKSI);

    switch (nappain) {
      case '?': avustus(nappain);                     break;
      case '0': return 0;
      case '1': lisaa_uusi_jasen(nappain);            break;
      case '2': etsi_jasenen_tiedot(nappain);         break;
      case '3': tulosteet(nappain);                   break;
      case '4': tietojen_korjailu(nappain);           break;
      case '5': paivita_jasenmaksuja(nappain);        break;
      default : cout << "Nin ei voi kyd!" << endl; return 1;
    }

  }
}


//----------------------------------------------------------------------------
void cNaytto::alusta(cKerho *p,const string &ohj_nimi)
{
  nykyjasen = -1;
  kerho = p;
  if ( ohj_nimi == "") ohjelman_nimi = "kerho";
  else ohjelman_nimi=ohj_nimi;
  help.alusta(ohjelman_nimi);
  edit_alusta("kerho.lyh");
}

//----------------------------------------------------------------------------
cNaytto::~cNaytto()
{
  kysy_talleta();
  edit_vapauta("kerho.lyh");
}
